<%--
 =================================================================
  Licensed Materials - Property of IBM

  WebSphere Commerce

  (C) Copyright IBM Corp. 2016 All Rights Reserved.

  US Government Users Restricted Rights - Use, duplication or
  disclosure restricted by GSA ADP Schedule Contract with
  IBM Corp.
 =================================================================
--%>

<%-- BEGIN GetOrderInfoForApplePay.jsp --%>

<%@ include file="../Common/EnvironmentSetup.jspf"%>
<% pageContext.setAttribute("lineBreak", "\n"); %> 

<c:if test="${!empty WCParam.orderId}">
    <wcf:rest var="order" url="store/{storeId}/order/{orderId}">
        <wcf:var name="storeId" value="${WCParam.storeId}" encode="true"/>
        <wcf:var name="orderId" value="${WCParam.orderId}" encode="true"/>
        <wcf:param name="pageSize" value="1"/>
        <wcf:param name="pageNumber" value="1"/>
        <wcf:param name="sortOrderItemBy" value="orderItemID"/>
    </wcf:rest>
</c:if>

<c:if test="${empty WCParam.orderId}">
    <wcf:rest var="order" url="store/{storeId}/cart/@self">
        <wcf:var name="storeId" value="${WCParam.storeId}" encode="true"/>
        <wcf:param name="pageSize" value="1"/>
        <wcf:param name="pageNumber" value="1"/>
        <wcf:param name="sortOrderItemBy" value="orderItemID"/>
    </wcf:rest>
</c:if>

<wcf:rest var="shipDetails" url="store/{storeId}/cart/@self/usable_shipping_info">
    <wcf:var name="storeId" value="${WCParam.storeId}" encode="true"/>
    <wcf:param name="pageSize" value="1"/>
    <wcf:param name="pageNumber" value="1"/>
</wcf:rest>

<c:set var="defaultShipModeId" value=""/>
<c:set var="isShipModeCorrect" value="false"/>
<c:forEach var="shippingMode" items="${shipDetails.orderItem[0].usableShippingMode}" varStatus="status">
	<c:if test="${shippingMode.shipModeCode != 'PickupInStore'}">
		<c:if test="${empty defaultShipModeId}">
			<c:set var="defaultShipModeId" value="${shippingMode.shipModeId}"/>
		</c:if>
		<c:if test="${shippingMode.shipModeId == order.orderItem[0].shipModeId}">
			<c:set var="defaultShipModeId" value="${order.orderItem[0].shipModeId}"/>
			<c:set var="isShipModeCorrect" value="true"/>
		</c:if>
	</c:if>
</c:forEach>

<c:set var="isBOPIS" value="false"/>
<c:if test="${!empty WCParam.shipModeId}">
	<c:set var="isBOPIS" value="true"/>
</c:if>
		
<c:choose>
	<c:when test="${!isShipModeCorrect && !isBOPIS && !empty defaultShipModeId}">
		/*
		{
			"defaultShipModeId": "<c:out value='${defaultShipModeId}'/>"
		}
		*/
	</c:when>
	<c:otherwise>
		<wcf:rest var="person" url="store/{storeId}/person/@self" scope="request">
			<wcf:var name="storeId" value="${WCParam.storeId}" encode="true"/>
		</wcf:rest>

		<%-- Get merchant configuration information, i.e. supportedNetworks and merchantCapabilities --%>
		<wcf:rest var="merchantInfo" url="store/{storeId}/applepay/merchant">
			<wcf:var name="storeId" value="${WCParam.storeId}" encode="true"/>
			<wcf:param name="paymentSystem" value="ApplePay" encode="true"/>
			<wcf:param name="paymentConfigGroup" value="default" encode="true"/>
			<wcf:param name="responseFormat" value="json" />
		</wcf:rest>

		<c:set var="key1" value="store/${WCParam.storeId}/country/country_state_list+${langId}"/>
		<c:set var="countryBean" value="${cachedOnlineStoreMap[key1]}"/>
		<c:if test="${empty countryBean}">
			<wcf:rest var="countryBean" url="store/{storeId}/country/country_state_list" cached="true">
				<wcf:var name="storeId" value="${WCParam.storeId}" />
				<wcf:param name="langId" value="${langId}" />
			</wcf:rest>
			<wcf:set target = "${cachedOnlineStoreMap}" key="${key1}" value="${countryBean}"/>
		</c:if>

		/*
		{
			   "currencyCode": "<c:out value='${env_currencyCode}'/>",
			   "countryCode": "<c:out value='${merchantInfo.merchantCountryCode}'/>",
			   "total": {
				  "label": "<c:out value='${storeName}'/>",
				  "amount": "<fmt:formatNumber value="${order.grandTotal}" type="number" groupingUsed="false" maxFractionDigits="2" minFractionDigits="0"/>"
			   },
			   "lineItems": [
					{"type": "final", "label":"<fmt:message bundle="${storeText}" key="MO_ORDERSUBTOTAL" />", "amount":"<fmt:formatNumber value="${order.totalProductPrice}" type="number" groupingUsed="false" maxFractionDigits="2" minFractionDigits="0"/>"},
					{"type": "final", "label":"<fmt:message bundle="${storeText}" key="DISCOUNT1" />", "amount":"<fmt:formatNumber value="${order.totalAdjustment}" type="number" groupingUsed="false" maxFractionDigits="2" minFractionDigits="0"/>"},
					{"type": "final", "label":"<fmt:message bundle="${storeText}" key="MO_TAX" />", "amount":"<fmt:formatNumber value="${order.totalSalesTax}" type="number" groupingUsed="false" maxFractionDigits="2" minFractionDigits="0"/>"},
					{"type": "final", "label":"<fmt:message bundle="${storeText}" key="MO_SHIPPING" />", "amount":"<fmt:formatNumber value="${order.totalShippingCharge}" type="number" groupingUsed="false" maxFractionDigits="2" minFractionDigits="0"/>"},
					{"type": "final", "label":"<fmt:message bundle="${storeText}" key="MO_SHIPPING_TAX" />", "amount":"<fmt:formatNumber value="${order.totalShippingTax}" type="number" groupingUsed="false" maxFractionDigits="2" minFractionDigits="0"/>"}
				],
				<c:choose>
					<c:when test="${isBOPIS}">
						"shippingType" : "storePickup",
					</c:when>
					<c:otherwise>
						<c:set var="contactInfoIdentifier" value="${shipDetails.usableShippingAddress[0]}"/>
						<c:if test="${person.addressId eq contactInfoIdentifier.addressId}" >
							<c:set var="countryDisplayName" value="${person.country}"/>
							<c:set var="stateDisplayName" value="${person.state}"/>
							<c:forEach var="country" items="${countryBean.countries}">
								<c:if test="${!empty country.code && country.code == person.country}">
									<c:set var="countryDisplayName" value="${country.displayName}"/>
								</c:if>
								<c:if test="${!empty country.states}">
									<c:forEach var="state" items="${country.states}" varStatus="counter">
										<c:if test="${!empty state.code && state.code == person.state}">
											<c:set var="stateDisplayName" value="${state.displayName}"/>
										</c:if>
									</c:forEach>
								</c:if>
							</c:forEach>
							"shippingContact" : {
								"givenName": "<c:out value='${person.firstName}'/>",
								"familyName": "<c:out value='${person.lastName}'/>",
								"addressLines": ["<c:out value='${person.addressLine[0]}'/>"],
								"locality": "<c:out value='${person.city}'/>",
								"administrativeArea": "<c:out value='${stateDisplayName}'/>",
								"country": "<c:out value='${countryDisplayName}'/>",
								"countryCode": "<c:out value='${person.country}'/>",
								"postalCode": "<c:out value='${person.zipCode}'/>",
								"emailAddress": "<c:out value='${person.email1}'/>",
								"phoneNumber": "<c:out value='${person.phone1}'/>"
							},
						</c:if>
						"shippingMethods": [
						<c:forEach var="shippingMode" items="${shipDetails.orderItem[0].usableShippingMode}" varStatus="status">
							<c:set var="shippingModeIdentifier" value="${shippingMode.shipModeId}"/>
							<c:if test="${shippingMode.shipModeCode != 'PickupInStore'}">
								<%-- Show all the shipping options available except for pickUp in Store --%>
								{
									"identifier":"<c:out value='${shippingModeIdentifier}'/>",
									"label":"<c:out value="${shippingMode.shipModeCode}"/>",
									"detail":"<c:out value="${shippingMode.description}"/>",
									"amount":"<c:out value="${shippingMode.xiush_amount}"/>"
								}<c:if test="${not status.last}">,</c:if>
							</c:if>
							
						</c:forEach>
						],
					   "shippingType" : "shipping",
					   "requiredShippingContactFields": [ "postalAddress", "phone", "email", "name" ],
					</c:otherwise>
				</c:choose>
			   "supportedNetworks": ${merchantInfo.supportedNetworks},
			   "merchantCapabilities": ${merchantInfo.merchantCapabilities},
			   "requiredBillingContactFields": [ "postalAddress", "phone", "email", "name" ]
		}
		*/
	</c:otherwise>
</c:choose>

<%-- END GetOrderInfoForApplePay.jsp --%>